#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=FfoxIcon.ico
#AutoIt3Wrapper_Outfile=../FireFox Loader.exe
#AutoIt3Wrapper_Res_Fileversion=2.1.1.82
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;#RequireAdmin
#AutoIt3Wrapper_Res_Icon_Add=Saved.ico
;Include autoit files
#Include <File.au3>
#Include <Array.au3>
#include <Misc.au3> ;for single instance
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <EDITConstants.au3>
#include <ProgressConstants.au3>
#include <StaticConstants.au3>
;Include Local script files
#include <DeleteOtherProfiles.au3> ;delete proflies
#include <EraseFunction.au3> ;tray item erase saved data
#include <AboutFunction.au3> ;about function
#include <ExitFunction.au3> ;exit function
#include <FirefoxVersionCheck.au3> ;firefox.exe version check
#include <PingFunc.au3> ;ping URL function
#Include <backup.au3> ;backup function
#Include <restore.au3>
#Include <runfox.au3>
#Include <runinstancefox.au3>
#Include <Settings.au3>
#Include <FolderIcon.au3>
#Include <FireFoxConfigFunction.au3>
#Include <FireFoxProfileManager.au3>
#Include <RegJumpFunction.au3>
TraySetToolTip ("FireFox loader")
;OnAutoItExitRegister("Backup") ;i dont want to use backup on exit because once loop exits, backup doest know where to save date so it stores it locallocaly :(
Global $Version = "2.3.7", $AppVersionFile = "/FireFox.version", $AppFile = "/FireFox.rar", $OSbit = @OSArch, $OS = @OSVersion
#comments-start ;end of wraped code
$Compiled = "FireFox Loader.exe"
$ScriptFileName = FileExists (@ScriptDir & "\" & $Compiled)
If $ScriptFileName = 0 Then
  MsgBox(16,"Error", "This is not original file name. Please rename this file back to " & @CRLF & "                                " & $Compiled)
  Exit
EndIf
if _Singleton($Compiled,1) = 0 Then
    RuninstanceFox()
    Exit
EndIf
#comments-end ;end of wraped code

FirefoxVersionCheck() ;compare stored saved version agains one installed
MainFunction() ;this function checks for firefox loader runs for the first time or not. or if all settings are complete.
Func MainFunction()
Opt("TrayOnEventMode",1)
Opt("TrayMenuMode",1+2)

$foxdirread = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "foxdir", "")
$CheckForCompletion = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "SettingsComplete", "")
If $CheckForCompletion = "" Then
	IniWrite (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "SettingsComplete", "No")
	;MsgBox(64,"Information","Not all settings are set." & @CRLF & "Please make sure options are set.")
	SettingsFunc()
	MainFunction()
EndIf

If $CheckForCompletion = "Yes" Then ;go firefox shit
	$ConnectionTray = TrayCreateMenu ("Tools/Settings")
	TrayCreateItem("AdBlock",$ConnectionTray)
	TrayItemSetOnEvent(-1,"AdBlock") ;function name
	TrayCreateItem("Plugins in Registry",$ConnectionTray)
	TrayItemSetOnEvent(-1,"PluginSRegistry") ;function name
	TrayCreateItem ("FireFox advanced config",$ConnectionTray)
	TrayItemSetOnEvent (-1,"FireFoxConfigFunction") ;function name
	TrayCreateItem ("FireFox Profile Manager",$ConnectionTray)
	TrayItemSetOnEvent (-1,"FireFoxProfileManager") ;function name
	TrayCreateItem ("",$ConnectionTray)
	TrayCreateItem ("Settings",$ConnectionTray)
	TrayItemSetOnEvent (-1,"SettingsFunc") ;Function name
	TrayCreateItem ("Set loader to 1st time use",$ConnectionTray)
	TrayItemSetOnEvent (-1,"Func1stTime") ;Function name
	TrayCreateItem ("Restart in Safe Mode")
	TrayItemSetOnEvent (-1,"SafeMode") ;function name
	TrayCreateItem("Backup Now")
	TrayItemSetOnEvent(-1,"Backup") ;function name
	TrayCreateItem("Delete Saved data")
	TrayItemSetOnEvent(-1,"EraseFunction") ;function name
	TrayCreateItem("Delete other profiles")
	TrayItemSetOnEvent(-1,"DeleteOtherProfiles") ;function name
	TrayCreateItem("About")
	TrayItemSetOnEvent(-1,"AboutFunction") ;function name
	TrayCreateItem('')
	TrayCreateItem('Exit')
	TrayItemSetOnEvent(-1,"ExitFunction") ;function name
	TraySetState(2)

	Global $OS, $OSbit, $RoamingDir
	Local $BackUpFolder = IniRead(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "backupdir", "") ;this is F:\Saved\FireFox\Username
	$admin = IsAdmin ( )
	$message1 = ("RESTORE ?" & @CRLF & 'Pressing "NO" will create backup when you close Firefox.')
	$message2 = ('Please close Firefox before using FireFox loader.' & @CRLF & '               FireFox loader will now exit')
	$FirstRun = "0"
	If FileExists (@UserProfileDir & "\FireFoxLoaderTimeStamp") = 0 Then Assign ("FirstRun",1) ; if file is not in windows folder, then assign first run to 1 so question will pop
	If FileExists ($BackUpFolder & "\FireFoxLoaderTimeStamp") = 0 Then FileWrite ($BackUpFolder & "\FireFoxLoaderTimeStamp",'')
	;File FireFoxLoaderTimeStamp written to UserProfileDir right before exit after each if
	$LocalTime = StringTrimRight (FileGetTime ($BackUpFolder & "\FireFoxLoaderTimeStamp",0,1),2)
	$RemoteTime = StringTrimRight (FileGetTime (@UserProfileDir & "\FireFoxLoaderTimeStamp",0,1),2)
	If $LocalTime > $RemoteTime Then Assign ("FirstRun",1) ;If file in UserProfileDir time is less then one in @scriptdir then pop the question.
	$saved = FileExists (@ScriptDir & "\Saved")
	If $OS = "Win_7" Then
		$RoamingDir = (@UserProfileDir & "\AppData\Roaming\Mozilla\Firefox")
	ElseIf $OS = "WIN_8" Then
		$RoamingDir = (@UserProfileDir & "\AppData\Roaming\Mozilla\Firefox")
	ElseIf $OS = "Win_Vista" Then
		$RoamingDir = (@UserProfileDir & "\AppData\Roaming\Mozilla\Firefox")
	ElseIf $OS = "Win_XP" Then
		$RoamingDir = (@UserProfileDir & "\Application Data\Mozilla\Firefox")
	ElseIf $OS = "Win_2008" Then
		$RoamingDir = (@UserProfileDir & "\AppData\Roaming\Mozilla\Firefox")
	ElseIf $OS = "Win_2003" Then
		$RoamingDir = (@UserProfileDir & "\Application Data\Mozilla\Firefox")
	EndIf
	$RunCheck = ProcessExists ("firefox.exe")
	$GetRoaming = _FileListToArray ($RoamingDir & "\Profiles")
	$ProfileName =  _ArrayToString ($GetRoaming,@TAB,1)
	$RoamingUser = ($RoamingDir & "\Profiles\" & $ProfileName)
	If $runcheck = 0 And $FirstRun = "1" Then ;restore function
		FirefoxVersionCheck()
		If IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "TestConnection", "") = "Yes" Then PingFunc()
		$AskToDelete = MsgBox (4+48,'Question',$message1)
		If $AskToDelete = 6 Then ;if RESTORE said yes
			If FileExists ($BackUpFolder) = 0 Then
				MsgBox (48,"Warning","You have nothing to restore. FireFox Loader will create Backup when you done.")
				RunFox()
				Backup()
				FileDelete ($BackUpFolder & "\FireFoxLoaderTimeStamp")
				FileWrite ($BackUpFolder & "\FireFoxLoaderTimeStamp",'')
				FileDelete (@UserProfileDir & "\FireFoxLoaderTimeStamp")
				FileWrite (@UserProfileDir & "\FireFoxLoaderTimeStamp",'')
				Exit
			Else
				DirRemove ($RoamingDir,1)
				Restore() ;this is why you press Yes
				RunFox()
				Backup()
				FileDelete ($BackUpFolder & "\FireFoxLoaderTimeStamp")
				FileWrite ($BackUpFolder & "\FireFoxLoaderTimeStamp",'')
				FileDelete (@UserProfileDir & "\FireFoxLoaderTimeStamp")
				FileWrite (@UserProfileDir & "\FireFoxLoaderTimeStamp",'')
				Exit
			EndIf
		ElseIf $AskToDelete = 7 Then ;if delete is not comfirmed by user
			$CheckFofSaved = FileExists (@ScriptDir & "\Saved")
			If $CheckFofSaved = 1 Then
				If IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "TestConnection", "") = "Yes" Then PingFunc()
				RunFox() ;no restore, this is why you press NO
				Backup()
				FileDelete ($BackUpFolder & "\FireFoxLoaderTimeStamp")
				FileWrite ($BackUpFolder & "\FireFoxLoaderTimeStamp",'')
				FileDelete (@UserProfileDir & "\FireFoxLoaderTimeStamp")
				FileWrite (@UserProfileDir & "\FireFoxLoaderTimeStamp",'')
				Exit
			Elseif $CheckFofSaved = 0 Then
				If IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "TestConnection", "") = "Yes" Then PingFunc()
				RunFox() ;no restore, this is because there was nothign saved before
				Backup()
				FileDelete ($BackUpFolder & "\FireFoxLoaderTimeStamp")
				FileWrite ($BackUpFolder & "\FireFoxLoaderTimeStamp",'')
				FileDelete (@UserProfileDir & "\FireFoxLoaderTimeStamp")
				FileWrite (@UserProfileDir & "\FireFoxLoaderTimeStamp",'')
				Exit
			EndIf
		Endif
	ElseIf 	$runcheck > 0 And $FirstRun = "0" Then ;run firefox as another instance
		RuninstanceFox()
	ElseIf 	$runcheck > 0 And $FirstRun = "1" Then ;run firefox as another instance
		MsgBox(64,'Information',$message2) ;close firefox loader ? because it ran for the first time while existing firefox was running.
		Exit
	ElseIf 	$runcheck = 0 And $FirstRun = "0" Then ;backup
		If IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "TestConnection", "") = "Yes" Then PingFunc()
		RunFox()
		Backup()
		FileDelete ($BackUpFolder & "\FireFoxLoaderTimeStamp")
		FileWrite ($BackUpFolder & "\FireFoxLoaderTimeStamp",'')
		FileDelete (@UserProfileDir & "\FireFoxLoaderTimeStamp")
		FileWrite (@UserProfileDir & "\FireFoxLoaderTimeStamp",'')
		Exit
	EndIf
	Exit
Elseif $CheckForCompletion = "No" Then
	MsgBox(64,"Information", "Not everything is setup. Please setup all parameters before continuing.")
	SettingsFunc()
EndIf
EndFunc

Func PluginSRegistry()
	_RegJump('HKEY_LOCAL_MACHINE\SOFTWARE\MozillaPlugins')
EndFunc   ;==>_RegJump
Func AdBlock()
	Local $localSource,$Destination,$GUI_AdBlock,$ProgressBar,$Start,$Apply
	Local $msg,$URL,$Download,$SizeRemote,$GetDownloadInfo,$Percent,$Copy
	$localSource = @TempDir & "\HOSTS"
	$Destination = @WindowsDir & "\System32\drivers\etc"
	If IniRead(@ScriptDir & "\" & @UserName & " Settings.ini", "settings", "hostsURL", "") = "" Then IniWrite (@ScriptDir & "\" & @UserName & " settings.ini","Settings","hostsURL","http://winhelp2002.mvps.org/hosts.txt")
	$URL = IniRead(@ScriptDir & "\" & @UserName & " Settings.ini", "settings", "hostsURL", "")
	$GUI_AdBlock = GUICreate ("AdBLock",200,40)
	$ProgressBar = GUICtrlCreateProgress (0,0,200,20)
	$Start = GUICtrlCreateButton ("Download",0,20,100,20)
	$Apply = GUICtrlCreateButton ("Apply",100,20,100,20)
	GUISetState (@SW_SHOW,$GUI_AdBlock)
	While 1
		$msg = GUIGetMsg()
		If $msg = $GUI_EVENT_CLOSE Then ExitLoop
		If $msg = $Start Then
			$Download = InetGet ($URL,$LocalSource,1,1) ;1 for force redownload all the time,1 for do nto wait to complete, go next line
			$SizeRemote = InetGetSize ($URL ,1)
			ProgressSet (0)
			While 1
				If InetGetInfo($Download, 2) Then exitloop
				$GetDownloadInfo = InetGetInfo ($Download,0)
				ConsoleWrite ($GetDownloadInfo/1024 & "KB Downloaded" & @CRLF)
				$Percent = Round($GetDownloadInfo*100/$SizeRemote, 2)
				GUICtrlSetData ($ProgressBar,$Percent)
				Sleep (100)
			WEnd
			GUICtrlSetData ($ProgressBar,100)
			MsgBox (0,'',"File downloaded to " & @CRLF & @TempDir)
			GUICtrlSetData ($ProgressBar,0)
		EndIf
		If $msg = $Apply Then
			$Copy = FileCopy (@TempDir & "\HOSTS",$Destination,1)
			If $Copy = 1 Then ;success copy
				MsgBox(32,"Information","HOSTS updated. Enjoy ad free browsing.")
			Else
				MsgBox (16,"Error","Unable to copy " & $localSource & " to " & $Destination & @CRLF & "Most likelyl caused by lack of administrative previledges or source file does not exist." & @CRLF & "Download the file and try again.")
			EndIf
		EndIf
	WEnd
	GUIDelete ($GUI_AdBlock)
EndFunc
Func Func1stTime() ;this function will erase windows firefoxloadertimestamp file so that loader will think it never ran befor
	Global $LocalTime
	$AskToReset = MsgBox (4+32,"Information","This will set firefox loader to think it runs for the first time." & @CRLF & "Firefox loader will exit without saving any data. Would you like to proceed ?")
	If $AskToReset = 6 Then
		FileDelete (@UserProfileDir & "\FireFoxLoaderTimeStamp")
		MsgBox (48,'Information',"Close firefox when done and restart FireFox loader for changes to take effect.")
		Exit
	EndIf
EndFunc
Func SafeMode()
	Local $AskToConfirm
	$AskToConfirm = MsgBox (4+32,"Information","This will restart Firefox and start it in Safe Mode with Addons disabled." & @CRLF & "Firefox will restart but loader will not. Would you like to proceed ?")
	If $AskToConfirm = 6 Then
		ProcessClose ("firefox.exe")
		While 1
			If ProcessExists ("firefox.exe") = 0 Then
				Run (IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "foxdir", "") & " -safe-mode")
				ExitLoop
			EndIf
		WEnd
	EndIf
EndFunc