Func SettingsFunc()
	TraySetToolTip ("Settings")
Local $runcheck, $CheckForCompletion, $AppVersionFile = "/FireFox.version", $AppFile = "/FireFox.rar"

Local $foxdirread = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "foxdir", "")
Local $Settings = GUICreate("FireFox loader settings",400,200)
#Region ;Main Tab
GUICtrlCreateTab (0,0,400,200)
GUICtrlCreateTabItem(" Main ")
GUICtrlCreateGroup ("FireFox location",10,30,380,50)
$FoXDirInput = GUICtrlCreateInput ($foxdirread,20,50,290,20)
GUICtrlSetTip ($FoXDirInput,"firefox.exe location is displayed here.","Quick Tip")
$BrowseFireFox = GUICtrlCreateButton ("Browse",320,50,60,20)
GUICtrlSetTip ($BrowseFireFox,"Press this button to locate firefox.exe file on your computer","Quick Tip")

GUICtrlCreateGroup ("Backup directory set automaticaly",10,80,380,50)
Local $BackupFolder = StringLeft (@ScriptFullPath,2)
$BackupDirInput = GUICtrlCreateInput (IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini","settings","backupdir",""),20,100,290,20)
If GUICtrlRead ($BackupDirInput) = "" Then GUICtrlSetData ($BackupDirInput,$BackupFolder & "\Saved\FireFox\" & @UserName)
If FileExists (IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini","settings","backupdir","")) = 0 Then
	;MsgBox(16,"Error",'"' & IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini","settings","backupdir","") & '" is not correct backup directory.' & @CRLF & 'Please open settings and correct the problem.')
	;dont really want to use it anymore. directory assigned automatically anyway.
EndIf
GUICtrlSetTip ($BackupDirInput,"Backup location is displayed here.","Quick Tip")
$BrowseBackup = GUICtrlCreateButton ("Browse",320,100,60,20)
GUICtrlSetTip ($BrowseBackup,"Press this button to locate backup directory.","Quick Tip")

GUICtrlCreateGroup ("Create Shortcut",10,130,200,65)
$CreateShortcutDesktop = GUICtrlCreateCheckbox ("Desktop",20,150)
GUICtrlSetTip ($CreateShortcutDesktop,"Check this box to select Desktop as shortcut destination.","Quick Tip")
$CreateShortcutQuickLauhch = GUICtrlCreateCheckbox ("Quick Launch",20,170)
GUICtrlSetTip ($CreateShortcutQuickLauhch,"Check this box to select Quick Launch as shortcut destination.","Quick Tip")
$CreateShortcutNow = GUICtrlCreateButton ("Create Now",120,150,80,40)
GUICtrlSetTip ($CreateShortcutNow,"Press this button to create shurtcut with destinations checked on the left.","Quick Tip")

GUICtrlCreateGroup ("Save options",220,130,170,50)
$SaveAll = GUICtrlCreateCheckbox ("Save All Settings on Close",230,150)
GUICtrlSetState ($SaveAll,$GUI_CHECKED)
GUICtrlSetTip ($SaveAll,"Check this box to save all settings on exit.","Quick Tip")
$ReadSaveAllFromINI = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "SaveOnExit", "")
If $ReadSaveAllFromINI = "Yes" Then
	GUICtrlSetState ($SaveAll,$GUI_CHECKED)
EndIf


#EndRegion ;End Main Tab

#Region ;Connection Tab
GUICtrlCreateTab (0,0,400,200)
GUICtrlCreateTabItem(" Connection ")
GUICtrlCreateGroup ("Check connection using",10,30,380,50)
$ReadURLFromINI = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "URL", "")
$URL = GUICtrlCreateInput ($ReadURLFromINI,20,50,200,20)
If $ReadURLFromINI = "" Then
	GUICtrlSetData ($URL,"google.com")
EndIf
GUICtrlCreateLabel ("Timeout",240,53)
$ReadTimeOutFromINI = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "URLTimeOut", "")
$TimeOut = GUICtrlCreateInput ($ReadTimeOutFromINI,280,50,20,20)
GUICtrlSetTip ($TimeOut,"Connection Timeout in secods.","Quick Tip")
If $ReadTimeOutFromINI = "" Then
	GUICtrlSetData ($TimeOut,"2")
EndIf

GUICtrlSetTip ($URL,"This is address to which connection is being made only to test your connection.","Quick Tip")
$CheckNow = GUICtrlCreateButton ("Check Now",315,50,70,20)
GUICtrlSetTip ($CheckNow,"Press this button to check for connection to specified address","Quick Tip")

$TestConnection = GUICtrlCreateCheckbox ("Test connection each Start",20,95)
GUICtrlSetTip ($TestConnection,"Check this box to test yor internet connection each time FirFox loader starts","Quick Tip")
$SaveTestConnectionOption = GUICtrlCreateButton ("Save Option's",240,95,140,20)
GUICtrlSetTip ($SaveTestConnectionOption,"Press this button to save current option","Quick Tip")
$GetTestConnectionStatusFromINI = IniRead(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "TestConnection", "")
If $GetTestConnectionStatusFromINI = "Yes" Then
	GUICtrlSetState ($TestConnection,$GUI_CHECKED)
Else
	GUICtrlSetState ($TestConnection,$GUI_UNCHECKED)
EndIf
GUICtrlCreateGroup ("Options",10,80,380,50)
#EndRegion ;End Connection Tab
#Region ;About Tab
GUICtrlCreateTab (0,0,400,200)
GUICtrlCreateTabItem(" About ")
GUICtrlCreateGroup ("About FireFox loader",10,30,380,160)
$AboutText = (@CRLF & "FireFox Loader V" & $Version & " originaly coded by [ADP]-Dirty. Website is no longer available." & @CRLF & "Loader coded using programming language 'Autoit' autoitscript.com" & @CRLF & @CRLF & "If you have any problem with this Loader, please send Email to" & @CRLF & "tonycst@hotmail.com")
If $OS = "WIN_XP" And $OSbit = "X86" Then
		$AboutEdit = GUICtrlCreateLabel ("FireFox Loader V" & $Version & " Windows XP 32bit " & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
	ElseIf $OS = "WIN_XP" And $OSbit = "X64" Then
		$AboutEdit = GUICtrlCreateLabel ("FireFox Loader V" & $Version & " Windows XP 64bit" & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
		ElseIf $OS = "WIN_7" And $OSbit = "X86" Then
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Windows 8 32bit" & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
	ElseIf $OS = "WIN_8" And $OSbit = "X64" Then
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Windows 8 64bit" & "User=" & @UserName & " " & $AboutText,20,50,360,130,$ES_CENTER)
	ElseIf $OS = "WIN_8" And $OSbit = "X86" Then
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Windows 7 32bit" & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
	ElseIf $OS = "WIN_7" And $OSbit = "X64" Then
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Windows 7 64bit" & "User=" & @UserName & " " & $AboutText,20,50,360,130,$ES_CENTER)
	ElseIf $OS = "WIN_Vista" And $OSbit = "X86" Then
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Windows Vista 32bit" & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
	ElseIf $OS = "WIN_Vista" And $OSbit = "X64" Then
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Windows Vista 64bit" & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
	ElseIf $OS = "WIN_2003" And $OSbit = "X32" Then
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Windows Server 2003 32bit" & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
	ElseIf $OS = "WIN_2003" And $OSbit = "X64" Then
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Windows Server 2003 64bit" & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
	ElseIf $OS = "WIN_2008" And $OSbit = "X32" Then
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Windows Server 2008 32bit" & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
	ElseIf $OS = "WIN_2008" And $OSbit = "X64" Then
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Windows Server 2008 64bit" & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
	Else
		$AboutEdit = GUICtrlCreateLabel  ("FireFox Loader V" & $Version & " Unknown OS " & "User=" & @UserName & " " & $AboutText,20,50,380,130,$ES_CENTER)
EndIf
;GUICtrlSetState ($AboutEdit,$GUI_DISABLE)
#EndRegion ;End About Tab

GUISetState(@SW_SHOW)

While 1
   $nMsg = GUIGetMsg()
   Switch $nMsg
	Case $GUI_EVENT_CLOSE
		If GUICtrlRead ($SaveAll) = $GUI_CHECKED Then
			;save all settings
			IniWrite(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "foxdir", GUICtrlRead ($FoXDirInput))
			IniWrite(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "backupdir", GUICtrlRead ($BackupDirInput))
			IniWrite(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "URL", GUICtrlRead ($URL))
			IniWrite(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "URLTimeOut", GUICtrlRead ($TimeOut))
			$SaveTestConnection = GUICtrlRead ($TestConnection) ;test connection at start up checkbox
			$SaveAllOnExit = GUICtrlRead ($SaveAll) ;automatic update checkgbox
			If $SaveTestConnection = $GUI_CHECKED Then IniWrite (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "TestConnection", "Yes")
			If $SaveTestConnection = $GUI_UNCHECKED Then IniWrite (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "TestConnection", "No")
			If $SaveAllOnExit = $GUI_CHECKED Then IniWrite (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "SaveOnExit", "Yes")
			If $SaveAllOnExit = $GUI_UNCHECKED Then IniWrite (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "SaveOnExit", "No")
		EndIf
ExitLoop
Case $BrowseFireFox
	If $OSbit = "X64" Then
		$firefox = FileOpenDialog ("Locate Firefox Executable", @HomeDrive & "\Program Files (x86)\Mozilla Firefox","firefox executable (firefox.exe)",1+2)
			If $firefox = "" Then
				MsgBox(0,'Error','No patch specified',"",$Settings)
			ElseIf $firefox > "" Then
				GUICtrlSetData ($FoXDirInput,$firefox)
				IniWrite(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "foxdir", $firefox)
			EndIf

	ElseIf $OSbit = "X86" Then
		$firefox = FileOpenDialog ("Locate Firefox Executable", @ProgramFilesDir & "\Mozilla Firefox","firefox executable (firefox.exe)",1+2)
			If $firefox = "" Then
				MsgBox(0,'Error','No patch specified',"",$Settings)
			ElseIf $firefox > "" Then
				GUICtrlSetData ($FoXDirInput,$firefox)
				IniWrite(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "foxdir", $firefox)
			EndIf
	EndIf

Case $BrowseBackup
	$backup = FileSelectFolder ("Select backup folder","",1+2+4)
		If $backup = "" Then
			MsgBox(0,'Error','No patch specified',"",$Settings)
		Elseif $backup > "" Then
			GUICtrlSetData ($BackupDirInput,$backup)
		EndIf
Case $CreateShortcutNow
		$ShortCutDesktopStatus = GUICtrlRead ($CreateShortcutDesktop)
		 $ShortCutQuickLaunchStatus = GUICtrlRead ($CreateShortcutQuickLauhch)
If $ShortCutDesktopStatus = $GUI_CHECKED And $ShortCutQuickLaunchStatus = $GUI_CHECKED Then
	FileCreateShortcut (@scriptdir & "\firefox loader.exe", @DesktopDir & "\firefox loader.lnk", @ScriptDir)
	FileCreateShortcut (@scriptdir & "\firefox loader.exe", @AppDataDir & "\Microsoft\Internet Explorer\Quick Launch\firefox loader.lnk", @ScriptDir)
	MsgBox(64,"Information","Desktop and Quick launch shortcut's were created.","",$Settings)
Elseif $ShortCutDesktopStatus = $GUI_UNCHECKED And $ShortCutQuickLaunchStatus = $GUI_UNCHECKED Then
	MsgBox(16,"Error","You did not select shortcut destination.","",$Settings)
ElseIf $ShortCutDesktopStatus = $GUI_CHECKED And $ShortCutQuickLaunchStatus = $GUI_UNCHECKED Then
	FileCreateShortcut (@scriptdir & "\firefox loader.exe", @DesktopDir & "\firefox loader.lnk", @ScriptDir)
	MsgBox(64,"Information","Desktop shortcut was created.","",$Settings)
ElseIf $ShortCutDesktopStatus = $GUI_UNCHECKED And $ShortCutQuickLaunchStatus = $GUI_CHECKED Then
	FileCreateShortcut (@scriptdir & "\firefox loader.exe", @AppDataDir & "\Microsoft\Internet Explorer\Quick Launch\firefox loader.lnk", @ScriptDir)
	MsgBox(64,"Information","Quick launch shortcut was created.","",$Settings)
EndIf

Case $CheckNow
		$ReadURLInpuit = GUICtrlRead ($URL)
		If $ReadURLInpuit = "" Then
			MsgBox (64,"Error","URL field cannot be empty.","",$Settings)
		ElseIf $ReadURLInpuit > "" Then
			IniWrite (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "URL", $ReadURLInpuit)
			TrayTip ("Status","Checking for  internet connection",99)
			$ReadURLFromINI = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "URL", "")
			$ReadTimeOutFromINI = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "URLTimeOut","")
			$Ping = Ping ($ReadURLFromINI,$ReadTimeOutFromINI)
			If $Ping = 0 Then
				TrayTip ("Status","Connection error",99)
				MsgBox(16,"Connection Check Error","Connection error. Please try another address or uncheck connection test option.","",$Settings)
			Elseif $Ping = 1 Then
				TrayTip ("Status","Connection error",99)
				MsgBox(16,"Connection Check Error","Connection error. Please try another address or uncheck connection test option.","",$Settings)
			ElseIf $Ping > 1 Then
				TrayTip ("Status","Connected !",99)
				MsgBox (64,"Status","Connected" & " in " & $Ping/60 & " second's","",$Settings)
			EndIf
		EndIf
		TrayTip ("","",1)

Case $SaveTestConnectionOption
	$GetConnectionBoxStatus = GUICtrlRead ($TestConnection)
If $GetConnectionBoxStatus = $GUI_CHECKED Then
	IniWrite(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "TestConnection", "Yes")
	MsgBox(64,"Information","Automatic connection test ''Enabled''","",$Settings)
ElseIf $GetConnectionBoxStatus = $GUI_UNCHECKED Then
	IniWrite(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "TestConnection", "No")
	MsgBox(64,"Information","Automatic connection test ''Disabled''","",$Settings)
EndIf
EndSwitch
WEnd
GUIDelete ($Settings)
If ProcessExists ("firefox.exe") = 0 And IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "SettingsComplete", "")= "Yes" Then
	;skip over so it will go to exit or do i need this ?
Else ;This section is to determine if YES needs to be written into SettingsComplete after its being checked once again
	$TestConnectionRead = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "TestConnection", "")
	$foxdirRead = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "foxdir", "")
	$BackupDirRead = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "backupdir", "")
	$URLRead = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "URL", "")
	$TimeOutRead = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "URLTimeOut","")
	If $TestConnectionRead  > "" And $foxdirRead > "" And $URLRead > "" And $TimeOut > "" And $BackupDirRead > "" Then
		IniWrite (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "SettingsComplete", "Yes")
	Else
		$AskToExit = MsgBox(1+64,"Hello !","Please Setup FireFox Loader settings." & @CRLF & 'Press "Cancel" to Exit this program')
		If $AskToExit = 2 Then
			Exit
		ElseIf $AskToExit = 1 Then
			SettingsFunc()
		EndIf
	EndIf
	$runcheck = ProcessExists ("firefox.exe")
	$CheckForCompletion = IniRead (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "SettingsComplete", "")
	If $runcheck = 0 And $CheckForCompletion = "Yes" Then
		MainFunction()
	EndIf
EndIf
EndFunc