Global $OS, $RoamingDir
Func Restore()
	TraySetToolTip ("Restore. Please wait.")
TrayTip ("Information","Progress... 10%",99,1)
Local $BackupFolder = IniRead(@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "backupdir", "")
Local $RestoreFrom, $AskToSetAsDefaultBackupDir, $AskWhatToDo, $asktoretry,$DefaultBackupFolder
If FileExists ($BackupFolder) = 0 Then
	While 1
		MsgBox(16,"Error","Previous Backup folder does not exist." & @CRLF & "Please manually select where to restore from." & @CRLF & "Selected folder must contain Roaming folder.")
		$RestoreFrom = FileSelectFolder ("Select Folder","",2)
		If $RestoreFrom = "" Then
			$AskWhatToDo = MsgBox (32+2,"Error","Nothing selected." & @CRLF& "What would you like to do ?")
			If $AskWhatToDo = 3 Then
				Exit
			Elseif $AskWhatToDo = 4 Then ;retry

			ElseIf $AskWhatToDo = 5 Then
				ExitLoop
			EndIf
		Else ;if restore folder returns something, check for existing folders.
			If FileExists ($RestoreFrom & "\Roaming") = 1 Then ;only if both folders are there, proceed
				$AskToSetAsDefaultBackupDir = MsgBox(32+4,"Question","Would you like to set this as your default Backup directory ?")
				If $AskToSetAsDefaultBackupDir = 6 Then ;if user said Yes assign selected folder as default backup directory
					IniWrite (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "backupdir", $RestoreFrom)
					Assign ("BackupFolder",$RestoreFrom)
					ExitLoop
				Else ; assign default backup directory in a root of hard drive saved/firefox/us$DefaultBackupFolderername
					$DefaultBackupFolder = StringLeft (@ScriptFullPath,2) & "\Saved\FireFox\" & @UserName ;Root/Saver/Firefox/Username
					MsgBox(32,"Information",'"' & $DefaultBackupFolder & '"' & ' Will be used to store your data next time.' & @CRLF & "You can change it in Settings dialogue.")
					IniWrite (@ScriptDir & "\" & @UserName & " " & "settings.ini", "settings", "backupdir", $DefaultBackupFolder)
					Assign ("BackupFolder",$RestoreFrom)
					ExitLoop
				EndIf
			Else
				$asktoretry = MsgBox (32+2,"Error","Roaming folders not found in this folder." & @CRLF & "Would you like to try another folder ?")
				If $asktoretry = 3 Then ;abort
					Exit
				ElseIf $asktoretry = 4 Then ;retry
					; not sure what hapends here
				ElseIf $asktoretry = 5 Then ;ignore
					ExitLoop
				EndIf
			EndIf
			Assign ("BackupFolder",$RestoreFrom)
		EndIf
	WEnd
EndIf

DirCreate ($BackupFolder & "\Roaming")
DirCreate ($RoamingDir)
TrayTip ("Information","Progress... 30%",99,1)

If $OS = "WIN_Vista" Then ;create folders and backup
	TrayTip ("Information","Restoring saved Windows 7 data","",100)
ElseIf $OS = "WIN_7" Then ;create folders and backup
	TrayTip ("Information","Restoring saved Windows 7 data","",100)
ElseIf $OS = "WIN_8" Then ;create folders and backup
	TrayTip ("Information","Restoring saved Windows 8 data","",100)
ElseIf $OS = "WIN_2008" Then ;create folders and backup
	TrayTip ("Information","Restoring saved Windows 2008 data","",100)
ElseIf $OS = "WIN_XP" Then
	TrayTip ("Information","Restoring saved XP data","",100)
ElseIf $OS = "WIN_2003" Then
	TrayTip ("Information","Restoring saved Windows server 2003 data","",100)
EndIf
TrayTip ("Information","Progress... 70%",99,1)
	RunWait (@ComSpec & ' /c xcopy /E/D/Y "' & $BackupFolder & '\Roaming" ' & '"' & $RoamingDir & '"', @ScriptDir,@SW_HIDE)
TrayTip ("Information","Progress... 100%",99,1)
TrayTip ("Information","Restoring complete","",1)
EndFunc
